Ext.data.JsonP.MobileCCS_ContactTypes({"tagname":"class","name":"MobileCCS.ContactTypes","autodetected":{"members":true},"files":[{"filename":"ccs-enums.js","href":null}],"enum":{"type":"String","default":null,"doc_only":null},"members":[{"name":"EMail","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-EMail","meta":{"readonly":true}},{"name":"Fax","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-Fax","meta":{"readonly":true}},{"name":"IM","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-IM","meta":{"readonly":true}},{"name":"Outbound","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-Outbound","meta":{"readonly":true}},{"name":"POMOutbound","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-POMOutbound","meta":{"readonly":true}},{"name":"SMS","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-SMS","meta":{"readonly":true}},{"name":"ScannedDocument","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-ScannedDocument","meta":{"readonly":true}},{"name":"SocialNetworking","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-SocialNetworking","meta":{"readonly":true}},{"name":"Video","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-Video","meta":{"readonly":true}},{"name":"Voice","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-Voice","meta":{"readonly":true}},{"name":"VoiceMail","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-VoiceMail","meta":{"readonly":true}},{"name":"WebChat","tagname":"property","owner":"MobileCCS.ContactTypes","id":"property-WebChat","meta":{"readonly":true}}],"alternateClassNames":[],"aliases":{},"id":"class-MobileCCS.ContactTypes","short_doc":"The ContactTypes class contains the definitions of the standard contact types defined by the Contact Control Service ...","component":false,"superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><div class='doc-contents'><p>The <em>ContactTypes</em> class contains the definitions of the standard contact types defined by the <strong>Contact Control Service</strong> SDK.</p>\n\n<p>The set of contact types defined by this class is not an exhaustive list\nsince other contact types could be defined as new functionality is added to the\nserver components.  However, the contact types defined in this class define the\nset of \"standard\" contact types that are provided by the Contact Center\nsuite of products.</p>\n<div class='rounded-box enum-box'><p><strong>ENUM:</strong> This enumeration defines a set of String values.</p></div></div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-property'>Properties</h3><div class='subsection'><div id='property-EMail' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-EMail' class='name expandable'>EMail</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>Identifies a contact as an E-Mail contact that has been created in the system by the Contact Center E-mail Manager. ...</div><div class='long'><p>Identifies a contact as an E-Mail contact that has been created in the system by the Contact Center E-mail Manager.</p>\n<p>Defaults to: <code>&quot;EMail&quot;</code></p></div></div></div><div id='property-Fax' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-Fax' class='name expandable'>Fax</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A fax contact. ...</div><div class='long'><p>A fax contact. A fax (short for facsimile) is a document sent over a telephone line.\nFaxes are forwarded by a fax server to an email address as a .tiff attachment.</p>\n<p>Defaults to: <code>&quot;Fax&quot;</code></p></div></div></div><div id='property-IM' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-IM' class='name expandable'>IM</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>An instant messaging contact. ...</div><div class='long'><p>An instant messaging contact.</p>\n<p>Defaults to: <code>&quot;IM&quot;</code></p></div></div></div><div id='property-Outbound' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-Outbound' class='name expandable'>Outbound</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>An outbound contact that has been created in the system by the Contact Center Outbound campaign manager. ...</div><div class='long'><p>An outbound contact that has been created in the system by the Contact Center Outbound campaign manager.</p>\n<p>Defaults to: <code>&quot;Outbound&quot;</code></p></div></div></div><div id='property-POMOutbound' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-POMOutbound' class='name expandable'>POMOutbound</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>An POM_Outbound contact that has been created in the system by the Avaya Proactive Outreach Manager (POM)\noutbound di...</div><div class='long'><p>An POM_Outbound contact that has been created in the system by the Avaya Proactive Outreach Manager (POM)\noutbound dialing environment.</p>\n<p>Defaults to: <code>&quot;POM_Outbound&quot;</code></p></div></div></div><div id='property-SMS' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-SMS' class='name expandable'>SMS</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A short message service (SMS) contact. ...</div><div class='long'><p>A short message service (SMS) contact. The Short Message Service (SMS) text message is a standard\ncommunications protocol for the exchange of short text messages between mobile phone devices.\nSMS messages are forwarded by an SMS gateway to an email address.</p>\n<p>Defaults to: <code>&quot;SMS&quot;</code></p></div></div></div><div id='property-ScannedDocument' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-ScannedDocument' class='name expandable'>ScannedDocument</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A scanned document contact. ...</div><div class='long'><p>A scanned document contact. A scanned document is an electronic version of a printed page or document.\nScanned documents are forwarded by a document imaging server to an e-mail address as a .tiff attachment.</p>\n<p>Defaults to: <code>&quot;Scanned_Document&quot;</code></p></div></div></div><div id='property-SocialNetworking' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-SocialNetworking' class='name expandable'>SocialNetworking</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A contact type for handling social media contacts from the Avaya Social Media Manager. ...</div><div class='long'><p>A contact type for handling social media contacts from the Avaya Social Media Manager.</p>\n<p>Defaults to: <code>&quot;Social_Networking&quot;</code></p></div></div></div><div id='property-Video' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-Video' class='name expandable'>Video</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A video contact. ...</div><div class='long'><p>A video contact.</p>\n<p>Defaults to: <code>&quot;Video&quot;</code></p></div></div></div><div id='property-Voice' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-Voice' class='name expandable'>Voice</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>Identifies a contact as a standard voice call using traditional or SIP-based telephony equipment. ...</div><div class='long'><p>Identifies a contact as a standard voice call using traditional or SIP-based telephony equipment.</p>\n<p>Defaults to: <code>&quot;Voice&quot;</code></p></div></div></div><div id='property-VoiceMail' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-VoiceMail' class='name expandable'>VoiceMail</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A voice mail contact. ...</div><div class='long'><p>A voice mail contact. A voicemail is a spoken message recorded on an answering machine.\nVoicemail messages are forwarded by a voicemail server to an email address as a .wav attachment.</p>\n<p>Defaults to: <code>&quot;Voice_Mail&quot;</code></p></div></div></div><div id='property-WebChat' class='member  not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='MobileCCS.ContactTypes'>MobileCCS.ContactTypes</span><br/></div><a href='#!/api/MobileCCS.ContactTypes-property-WebChat' class='name expandable'>WebChat</a> : String<span class=\"signature\"><span class='readonly' >readonly</span></span></div><div class='description'><div class='short'>A web chat contact that has been created in the system by the Contact Center Web Communications Manager. ...</div><div class='long'><p>A web chat contact that has been created in the system by the Contact Center Web Communications Manager.</p>\n<p>Defaults to: <code>&quot;Web_Communications&quot;</code></p></div></div></div></div></div></div></div>","meta":{}});