Ext.data.JsonP.global({"tagname":"class","name":"global","alternateClassNames":[],"members":[{"name":"CustomerSearch","tagname":"method","owner":"global","id":"method-CustomerSearch","meta":{}}],"aliases":{},"files":[{"filename":"","href":""}],"component":false,"superclasses":[],"subclasses":[],"mixedInto":[],"mixins":[],"parentMixins":[],"requires":[],"uses":[],"html":"<div><div class='doc-contents'><p>Global variables and functions.</p>\n</div><div class='members'><div class='members-section'><div class='definedBy'>Defined By</div><h3 class='members-title icon-method'>Methods</h3><div class='subsection'><div id='method-CustomerSearch' class='member first-child not-inherited'><a href='#' class='side expandable'><span>&nbsp;</span></a><div class='title'><div class='meta'><span class='defined-in' rel='global'>global</span><br/></div><a href='#!/api/global-method-CustomerSearch' class='name expandable'>CustomerSearch</a>( <span class='pre'>handler</span> ) : void<span class=\"signature\"></span></div><div class='description'><div class='short'>Searches for a Customer from the server based on a specified search criteria object. ...</div><div class='long'><p>Searches for a Customer from the server based on a specified search criteria object. The matching customer list\nis passed to the callback function supplied by the <em>handler</em> argument whose function signature should be as follows:</p>\n\n<pre><code>callbackFunc(notifyType, notifyObject)\n</code></pre>\n\n<p>The first argument to the callback function identifies the type of notification being supplied, which is defined in\n<a href=\"#!/api/MobileCCS.NotifyTypes\" rel=\"MobileCCS.NotifyTypes\" class=\"docClass\">NotifyTypes</a> and will be one of either <em>RESPONSE</em> or <em>ERROR</em>.  The second argument will be a\n<em>CustomerList</em> object for the <em>RESPONSE</em> notification type or an <a href=\"#!/api/MobileCCS.Error\" rel=\"MobileCCS.Error\" class=\"docClass\">Error</a> object for the\n<em>ERROR</em> notification type.</p>\n\n<p>A <em>RESPONSE</em> notification indicates that a <em>CustomerList</em> object is being returned containing the Customers that matched the\nsearch criteria specified by the User. The format of the <em>CustomerList</em> object is as follows:</p>\n\n<ul>\n<li><strong>Customers</strong> - An array of <em>Customer</em> objects. The format of the <em>Customer</em> object is as follows:\n   <strong>ID</strong>\n   <strong>Title</strong>\n   <strong>FirstName</strong>\n   <strong>LastName</strong>\n   <strong>RegisterDate</strong>\n   <strong>PhoneList</strong>\n   <strong>EmailAddresses</strong>\n   <strong>AddressList</strong></li>\n</ul>\n\n\n<p>An <em>ERROR</em> notification received on this callback function indicates the failure of the method call. The accompanying\n<a href=\"#!/api/MobileCCS.Error\" rel=\"MobileCCS.Error\" class=\"docClass\">Error</a> object provides details as to the source and cause of the error.</p>\n\n<p>Possible errors for this method are listed below.  If the meaning of the error code in the context of this method\ndiffers significantly from the generic description given for that error code, then a context-specific meaning is given.</p>\n\n<table style=\"max-width:900px;\">\n    <tbody valign=\"top\">\n        <tr style=\"font-weight:bold\">\n            <td>Error Codes</td>\n            <td>Context-Specific Meaning</td>\n        </tr>\n        <tr>\n            <td><a href=\"#!/api/MobileCCS.ErrorCode-property-ServerCommunicationFailure\" rel=\"MobileCCS.ErrorCode-property-ServerCommunicationFailure\" class=\"docClass\">ServerCommunicationFailure</a></td>\n        </tr>\n    </tbody>\n</table>\n\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>handler</span> : Function<div class='sub-desc'><p>This mandatory callback function is called when the response arrives.  See above for\n                             a description of this callback function.</p>\n<h3 class=\"pa\">Parameters</h3><ul><li><span class='pre'>notifyType</span> : String<div class='sub-desc'><p>Identifies the type of notification being supplied (see <a href=\"#!/api/MobileCCS.NotifyTypes\" rel=\"MobileCCS.NotifyTypes\" class=\"docClass\">NotifyTypes</a>).</p>\n</div></li><li><span class='pre'>notifyObject</span> : Object<div class='sub-desc'><p>Depending on the notification type, this will be either a <em>CodeList</em>\n                                     object or an <a href=\"#!/api/MobileCCS.Error\" rel=\"MobileCCS.Error\" class=\"docClass\">Error</a> object.</p>\n</div></li></ul></div></li></ul><h3 class='pa'>Returns</h3><ul><li><span class='pre'>void</span><div class='sub-desc'>\n</div></li></ul></div></div></div></div></div></div></div>","meta":{}});